<?xml version="1.0"?>
<!--
Copyright (C) 2006  Romain Lenglet
All rights reserved.
The contents of this file are subject to the Modified BSD License.
See the file "COPYING" for licensing details.
-->

<xsl:stylesheet version='1.0'
    xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
    xmlns:dryverl='http://objectweb.org/dryverl-0.1'>

<xsl:output method='text'/>

<!-- Empty template in case there is no gen-driver element! -->
<xsl:template match='/dryverl:def-bindings[not(dryverl:gen-driver)]'>
</xsl:template>

<xsl:template match='/dryverl:def-bindings[dryverl:gen-driver]'>
<!-- NOTE: this must be synchronized with the same variable definition
     in the stylesheet that generates the .h file -->
<xsl:variable name='first-user-command-id' select='2'/>
-module(<xsl:value-of select='dryverl:gen-driver/@erlang-front-end-module-name'/>).

-export([
<xsl:for-each select='dryverl:def-erlang-to-c-binding/dryverl:def-erlang-input'>
<xsl:variable name='has-output' select='boolean(../dryverl:encode-output)'/>
<xsl:if test='position() > 1'>, </xsl:if>
<xsl:choose>
<xsl:when test='$has-output'>
<xsl:value-of select='@function-name'/>/<xsl:value-of select='2+count(dryverl:def-erlang-arg)'/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select='@function-name'/>/<xsl:value-of select='1+count(dryverl:def-erlang-arg)'/>
</xsl:otherwise>
</xsl:choose>
</xsl:for-each>
]).

<xsl:for-each select='dryverl:def-erlang-to-c-binding/dryverl:def-erlang-input'>
<xsl:variable name='has-output' select='boolean(../dryverl:encode-output)'/>

%% @spec <xsl:value-of select='@function-name'/>(__ServerRef<xsl:if test='$has-output'>, __Timeout</xsl:if><xsl:for-each select='dryverl:def-erlang-arg'>, <xsl:value-of select='@name'/></xsl:for-each>) -><xsl:choose><xsl:when test='$has-output'>
%%      __Reply</xsl:when><xsl:otherwise>
%%      ok</xsl:otherwise></xsl:choose>
%% __ServerRef = __Name | {__Name, __Node} | {global, __GlobalName} | pid()
%%   __Node = atom()
%%   __GlobalName = term()<xsl:if test='$has-output'>
%% __Timeout = int()>0 | infinity</xsl:if><xsl:for-each select='dryverl:def-erlang-arg'>
%% <xsl:value-of select='@name'/> = <xsl:value-of select='@type-doc'/>
</xsl:for-each>
<xsl:for-each select='dryverl:def-erlang-type-doc'>
%% <xsl:apply-templates/>
</xsl:for-each>
<xsl:if test='$has-output'>
%% __Reply = <xsl:value-of select='../dryverl:def-erlang-output/dryverl:def-erlang-return/@type-doc'/>
<xsl:for-each select='../dryverl:def-erlang-output/dryverl:def-erlang-type-doc'>
%% <xsl:apply-templates/>
</xsl:for-each>
</xsl:if><xsl:text>
</xsl:text><xsl:value-of select='@function-name'/>(__ServerRef, __Timeout<xsl:for-each select='dryverl:def-erlang-arg'>, __Arg<xsl:value-of select='@name'/></xsl:for-each>) ->
<xsl:choose>
<xsl:when test='$has-output'>
    gen_server:call(__ServerRef, {call, <xsl:value-of select='@function-name'/><xsl:if test='dryverl:def-erlang-arg'>, [<xsl:for-each select='dryverl:def-erlang-arg'><xsl:if test='position() > 1'>, </xsl:if>__Arg<xsl:value-of select='@name'/></xsl:for-each>]</xsl:if>}, __Timeout).
</xsl:when>
<xsl:otherwise>
    gen_server:cast(__ServerRef, {call, <xsl:value-of select='@function-name'/><xsl:if test='dryverl:def-erlang-arg'>, [<xsl:for-each select='dryverl:def-erlang-arg'><xsl:if test='position() > 1'>, </xsl:if>__Arg<xsl:value-of select='@name'/></xsl:for-each>]</xsl:if>}).
</xsl:otherwise>
</xsl:choose>
</xsl:for-each>

</xsl:template>

</xsl:stylesheet>

